<?php
// $Id: published.views.inc,v 1.1.2.1 2010/06/29 15:02:53 ptalindstrom Exp $ 


/***
*       Add Views support
* 
*/

/**
 * Implementation of hook_views_plugins
 */
function published_views_plugins() {
  return array(
    'module' => 'views', // This just tells views our themes are in Views.
    'row' => array(
      'unformatted' => array(
        'title' => t('Unformatted'),
        'help' => t('(Displays the unformatted data for each row from the views query with each row on a new line. Set as | for views_json.'),
        'handler' => 'views_plugin_row_unformatted',
        'theme' => 'views_view_row_unformatted',
        'uses fields' => TRUE,
        'uses options' => TRUE,
        'type' => 'normal',
      )
    ), 
  );
}


/**
 * Implementation of hook_views_tables().
 *
 */
function published_views_data() {
  $data = array();
  
  $data['published']['table']['base'] = array(
    'field' => 'nid',
    'title' => t('Published time'),
    'help' => t('The time that the node transitioned to Published.'),
  );
  
  $data['published']['table']['group']  = t('Node');
  
  $data['published']['table']['join'] = array(
    'node' => array(
      'left_field' => 'nid',
      'field' => 'nid',
    ),
  );
  
  // timestamp (when Node was published)
  $data['published']['published'] = array(
    'title' => t('Published date'),
    'help' => t('Date and time of when the node was published.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'date_api_argument_handler',
    ),
  );
 
  return $data;
} 

function published_date_api_fields($field) {
  if ($field == 'published.published') {
    return array(
      // The type of date: DATE_UNIX, DATE_ISO, DATE_DATETIME.
      'sql_type' => DATE_UNIX,
      // Timezone handling options: 'none', 'site', 'date', 'utc'.
      'tz_handling' => 'site',
      // Granularity of this date field's db data.
      'granularity' => array('year', 'month', 'day', 'hour', 'minute', 'second'),
    );
  }
}
